qlserver 4.1 KB

123456789101112131415161718192021222324252627282930313233343536373839404142434445464748495051525354555657585960616263646566676869707172737475767778798081828384858687888990919293949596979899100101102103104105106107108109110111112113114115116117118119120121122123124125126127128129130131132133134135136137138139140141142143144145146147148149150151152153154155156157158159160
  1. #!/bin/bash
  2. # Quake Live
  3. # Server Management Script
  4. # Author: Daniel Gibbs
  5. # Website: https://gameservermanagers.com
  6. if [ -f ".dev-debug" ]; then
  7. exec 5>dev-debug.log
  8. BASH_XTRACEFD="5"
  9. set -x
  10. fi
  11. version="060516"
  12. #### Variables ####
  13. # Notification Alerts
  14. # (on|off)
  15. # Email
  16. emailalert="off"
  17. email="email@example.com"
  18. # Pushbullet
  19. # https://www.pushbullet.com/#settings
  20. pushbulletalert="off"
  21. pushbullettoken="accesstoken"
  22. # Steam login
  23. steamuser="anonymous"
  24. steampass=""
  25. # Start Variables
  26. arch="x64" # x64 or x86
  27. port="27960"
  28. rconport="28960"
  29. rconpassword="CHANGE_ME"
  30. statsport="${port}"
  31. statspassword="CHANGE_ME"
  32. mappool='mappool.txt'
  33. ip="0.0.0.0"
  34. updateonstart="off"
  35. # Install/Config Guide : https://steamcommunity.com/sharedfiles/filedetails/?id=542966946
  36. # Console Commands : http://www.regurge.at/ql/
  37. fn_parms(){
  38. parms="+set net_strict 1 +set net_ip ${ip} +set net_port ${port} +set fs_homepath ${filesdir}/${port} +set zmq_rcon_enable 1 +set zmq_rcon_port ${rconport} +set zmq_rcon_password ${rconpassword} +set zmq_stats_enable 1 +set zmq_stats_password ${statspassword} +set zmq_stats_port ${statsport} +set sv_mapPoolFile ${mappool} +exec ${servercfg}"
  39. }
  40. #### Advanced Variables ####
  41. # Github Branch Select
  42. # Allows for the use of different function files
  43. # from a different repo and/or branch.
  44. githubuser="GameServerManagers"
  45. githubrepo="LinuxGSM"
  46. githubbranch="master"
  47. # Steam
  48. appid="349090"
  49. # Server Details
  50. servicename="ql-server"
  51. gamename="Quake Live"
  52. engine="idtech3"
  53. # Directories
  54. rootdir="$(dirname $(readlink -f "${BASH_SOURCE[0]}"))"
  55. selfname="$(basename $(readlink -f "${BASH_SOURCE[0]}"))"
  56. lockselfname=".${servicename}.lock"
  57. lgsmdir="${rootdir}/lgsm"
  58. functionsdir="${lgsmdir}/functions"
  59. libdir="${lgsmdir}/lib"
  60. filesdir="${rootdir}/serverfiles"
  61. systemdir="${filesdir}"
  62. executabledir="${filesdir}"
  63. executable=$([ "${arch}" == 'x64' ] && echo "./run_server_x64.sh" || echo "./run_server_x86.sh")
  64. servercfg="${servicename}.cfg"
  65. servercfgdir="${filesdir}/baseq3"
  66. servercfgfullpath="${servercfgdir}/${servercfg}"
  67. servercfgdefault="${servercfgdir}/lgsm-default.cfg"
  68. backupdir="${rootdir}/backups"
  69. # Logging
  70. logdays="7"
  71. gamelogdir="${rootdir}/log/server"
  72. scriptlogdir="${rootdir}/log/script"
  73. consolelogdir="${rootdir}/log/console"
  74. consolelogging="on"
  75. gamelog="${gamelogdir}/${servicename}-game.log"
  76. scriptlog="${scriptlogdir}/${servicename}-script.log"
  77. consolelog="${consolelogdir}/${servicename}-console.log"
  78. emaillog="${scriptlogdir}/${servicename}-email.log"
  79. scriptlogdate="${scriptlogdir}/${servicename}-script-$(date '+%d-%m-%Y-%H-%M-%S').log"
  80. consolelogdate="${consolelogdir}/${servicename}-console-$(date '+%d-%m-%Y-%H-%M-%S').log"
  81. ##### Script #####
  82. # Do not edit
  83. # Fetches core_dl for file downloads
  84. fn_fetch_core_dl(){
  85. github_file_url_dir="lgsm/functions"
  86. github_file_url_name="${functionfile}"
  87. filedir="${functionsdir}"
  88. filename="${github_file_url_name}"
  89. githuburl="https://raw.githubusercontent.com/${githubuser}/${githubrepo}/${githubbranch}/${github_file_url_dir}/${github_file_url_name}"
  90. # If the file is missing, then download
  91. if [ ! -f "${filedir}/${filename}" ]; then
  92. if [ ! -d "${filedir}" ]; then
  93. mkdir -p "${filedir}"
  94. fi
  95. echo -e " fetching ${filename}...\c"
  96. # Check curl exists and use available path
  97. curlpaths="$(command -v curl 2>/dev/null) $(which curl >/dev/null 2>&1) /usr/bin/curl /bin/curl /usr/sbin/curl /sbin/curl)"
  98. for curlcmd in ${curlpaths}
  99. do
  100. if [ -x "${curlcmd}" ]; then
  101. break
  102. fi
  103. done
  104. # If curl exists download file
  105. if [ "$(basename ${curlcmd})" == "curl" ]; then
  106. curlfetch=$(${curlcmd} -s --fail -o "${filedir}/${filename}" "${githuburl}" 2>&1)
  107. if [ $? -ne 0 ]; then
  108. echo -e "\e[0;31mFAIL\e[0m\n"
  109. echo "${curlfetch}"
  110. echo -e "${githuburl}\n"
  111. exit 1
  112. else
  113. echo -e "\e[0;32mOK\e[0m"
  114. fi
  115. else
  116. echo -e "\e[0;31mFAIL\e[0m\n"
  117. echo "Curl is not installed!"
  118. echo -e ""
  119. exit 1
  120. fi
  121. chmod +x "${filedir}/${filename}"
  122. fi
  123. source "${filedir}/${filename}"
  124. }
  125. core_dl.sh(){
  126. # Functions are defined in core_functions.sh.
  127. functionfile="${FUNCNAME}"
  128. fn_fetch_core_dl
  129. }
  130. core_functions.sh(){
  131. # Functions are defined in core_functions.sh.
  132. functionfile="${FUNCNAME}"
  133. fn_fetch_core_dl
  134. }
  135. core_dl.sh
  136. core_functions.sh
  137. getopt=$1
  138. core_getopt.sh